import { toError } from "../jsutils/toError.mjs";

import { GraphQLError } from "../shared.mjs";

function locatedError(rawOriginalError, nodes, path) {
  var _nodes;
  const originalError = toError(rawOriginalError);
  if (function isLocatedGraphQLError(error) {
    return Array.isArray(error.path);
  }(originalError)) {
    return originalError;
  }
  return new GraphQLError(originalError.message, {
    nodes: null !== (_nodes = originalError.nodes) && void 0 !== _nodes ? _nodes : nodes,
    source: originalError.source,
    positions: originalError.positions,
    path,
    originalError
  });
}

export { locatedError };
