var shared = require("../shared.js");

function isExecutableDefinitionNode(node) {
  return node.kind === shared.e.OPERATION_DEFINITION || node.kind === shared.e.FRAGMENT_DEFINITION;
}

function isTypeSystemDefinitionNode(node) {
  return node.kind === shared.e.SCHEMA_DEFINITION || isTypeDefinitionNode(node) || node.kind === shared.e.DIRECTIVE_DEFINITION;
}

function isTypeDefinitionNode(node) {
  return node.kind === shared.e.SCALAR_TYPE_DEFINITION || node.kind === shared.e.OBJECT_TYPE_DEFINITION || node.kind === shared.e.INTERFACE_TYPE_DEFINITION || node.kind === shared.e.UNION_TYPE_DEFINITION || node.kind === shared.e.ENUM_TYPE_DEFINITION || node.kind === shared.e.INPUT_OBJECT_TYPE_DEFINITION;
}

function isTypeSystemExtensionNode(node) {
  return node.kind === shared.e.SCHEMA_EXTENSION || isTypeExtensionNode(node);
}

function isTypeExtensionNode(node) {
  return node.kind === shared.e.SCALAR_TYPE_EXTENSION || node.kind === shared.e.OBJECT_TYPE_EXTENSION || node.kind === shared.e.INTERFACE_TYPE_EXTENSION || node.kind === shared.e.UNION_TYPE_EXTENSION || node.kind === shared.e.ENUM_TYPE_EXTENSION || node.kind === shared.e.INPUT_OBJECT_TYPE_EXTENSION;
}

exports.isDefinitionNode = function isDefinitionNode(node) {
  return isExecutableDefinitionNode(node) || isTypeSystemDefinitionNode(node) || isTypeSystemExtensionNode(node);
};

exports.isExecutableDefinitionNode = isExecutableDefinitionNode;

exports.isSelectionNode = function isSelectionNode(node) {
  return node.kind === shared.e.FIELD || node.kind === shared.e.FRAGMENT_SPREAD || node.kind === shared.e.INLINE_FRAGMENT;
};

exports.isTypeDefinitionNode = isTypeDefinitionNode;

exports.isTypeExtensionNode = isTypeExtensionNode;

exports.isTypeNode = function isTypeNode(node) {
  return node.kind === shared.e.NAMED_TYPE || node.kind === shared.e.LIST_TYPE || node.kind === shared.e.NON_NULL_TYPE;
};

exports.isTypeSystemDefinitionNode = isTypeSystemDefinitionNode;

exports.isTypeSystemExtensionNode = isTypeSystemExtensionNode;

exports.isValueNode = function isValueNode(node) {
  return node.kind === shared.e.VARIABLE || node.kind === shared.e.INT || node.kind === shared.e.FLOAT || node.kind === shared.e.STRING || node.kind === shared.e.BOOLEAN || node.kind === shared.e.NULL || node.kind === shared.e.ENUM || node.kind === shared.e.LIST || node.kind === shared.e.OBJECT;
};
