var type_assertName = require("../type/assertName.js");

var shared = require("../shared.js");

function isValidNameError(name) {
  if (name.startsWith("__")) {
    return new shared.GraphQLError(`Name "${name}" must not begin with "__", which is reserved by GraphQL introspection.`);
  }
  try {
    type_assertName.assertName(name);
  } catch (error) {
    return error;
  }
}

exports.assertValidName = function assertValidName(name) {
  const error = isValidNameError(name);
  if (error) {
    throw error;
  }
  return name;
};

exports.isValidNameError = isValidNameError;
