import { naturalCompare } from "../jsutils/naturalCompare.mjs";

import { e } from "../shared.mjs";

function sortValueNode(valueNode) {
  switch (valueNode.kind) {
   case e.OBJECT:
    return {
      ...valueNode,
      fields: (fields = valueNode.fields, fields.map((fieldNode => ({
        ...fieldNode,
        value: sortValueNode(fieldNode.value)
      }))).sort(((fieldA, fieldB) => naturalCompare(fieldA.name.value, fieldB.name.value))))
    };

   case e.LIST:
    return {
      ...valueNode,
      values: valueNode.values.map(sortValueNode)
    };

   case e.INT:
   case e.FLOAT:
   case e.STRING:
   case e.BOOLEAN:
   case e.NULL:
   case e.ENUM:
   case e.VARIABLE:
    return valueNode;
  }
  var fields;
}

export { sortValueNode };
