var language_predicates = require("../../language/predicates.js");

var shared = require("../../shared.js");

exports.ExecutableDefinitionsRule = function ExecutableDefinitionsRule(context) {
  return {
    Document(node) {
      for (const definition of node.definitions) {
        if (!language_predicates.isExecutableDefinitionNode(definition)) {
          context.reportError(new shared.GraphQLError(`The ${definition.kind === shared.e.SCHEMA_DEFINITION || definition.kind === shared.e.SCHEMA_EXTENSION ? "schema" : '"' + definition.name.value + '"'} definition is not executable.`, {
            nodes: definition
          }));
        }
      }
      return !1;
    }
  };
};
