var type_definition = require("../../../type/definition.js");

var type_introspection = require("../../../type/introspection.js");

var shared = require("../../../shared.js");

exports.NoSchemaIntrospectionCustomRule = function NoSchemaIntrospectionCustomRule(context) {
  return {
    Field(node) {
      const type = type_definition.getNamedType(context.getType());
      if (type && type_introspection.isIntrospectionType(type)) {
        context.reportError(new shared.GraphQLError(`GraphQL introspection has been disabled, but the requested query contained the field "${node.name.value}".`, {
          nodes: node
        }));
      }
    }
  };
};
